module dwt.internal.mozilla.nsIHelperAppLauncherDialog;

import dwt.internal.mozilla.Common;
import dwt.internal.mozilla.nsID;
import dwt.internal.mozilla.nsISupports;
import dwt.internal.mozilla.nsIExternalHelperAppService;
import dwt.internal.mozilla.nsILocalFile;

const char[] NS_IHELPERAPPLAUNCHERDIALOG_IID_STR = "64355793-988d-40a5-ba8e-fcde78cac631";

const nsIID NS_IHELPERAPPLAUNCHERDIALOG_IID= 
  {0x64355793, 0x988d, 0x40a5, 
    [ 0xba, 0x8e, 0xfc, 0xde, 0x78, 0xca, 0xc6, 0x31 ]};

extern(System)

interface nsIHelperAppLauncherDialog : nsISupports {

  static const char[] IID_STR = NS_IHELPERAPPLAUNCHERDIALOG_IID_STR;
  static const nsIID IID = NS_IHELPERAPPLAUNCHERDIALOG_IID;

  enum { REASON_CANTHANDLE = 0U };
  enum { REASON_SERVERREQUEST = 1U };
  enum { REASON_TYPESNIFFED = 2U };
  nsresult Show(nsIHelperAppLauncher aLauncher, nsISupports aContext, PRUint32 aReason);
  nsresult PromptForSaveToFile(nsIHelperAppLauncher aLauncher, nsISupports aWindowContext, PRUnichar *aDefaultFile, PRUnichar *aSuggestedFileExtension, nsILocalFile *_retval);

}

